**********************************************************************
*     INGMAPTOPS.FOR is run by INGMAPTOPS.BUILD in conjunction with  *
*     INGRES retrieval as a batch job on the que BIG$JOB.            *
*     MAPTOPS.FOR converts files retrieved in INGRES from WHCS       *
*     header records and tops files using DCL commands (MAP_TOPS)    *
*     into a one line fixed format file.  This format can contain up *
*     to six formation tops, formation code, formation age code API, *
*     longitude, latitude, elevation, elevation reference, township, *
*     range, section, well number, lease name, and operator.  The    *
*     program queries the user an output file name, elevation refer- *
*     ence corrections to kelly bushing, and up to six formation     *
*     names plus one name variation for the first two formations.    *
*     
**********************************************************************  


      CHARACTER*32 OUTFILE
      CHARACTER*15 LNAME,OPER,LNAME1,OPER1
      CHARACTER*14 API,API1
      CHARACTER*10 TRS,WELLN,TRS1,WELLN1
      CHARACTER*8  SPOT,SPOT1
      CHARACTER*4  FORM,FORM1,FORMA,FORMB,FORMC,FORMD,
     *             FORME,FORMF,FMA,FMB,FMC,
     *             FMA1,FMB1,FMD,FME,FMF
      CHARACTER*3  FMAGE,FMAGE1,FMAGEA,FMAGEB,FMAGEC,FMAGED,
     *             FMAGEE,FMAGEF
      CHARACTER*2  ELEVR,ELEVR1
      CHARACTER*1  FMAZ,FMBZ,FMCZ,FMDZ,FMEZ,FMFZ,FMZ,FMZ1
      INTEGER      ELEVGR,ELEVDF,ELEVRB,ELEVRT,ELEV,ELEV1
      REAL         LONG,LAT,LONG1,LAT1
      CHARACTER*5  FTPA,FTPB,FTPC,FTPD,FTPE,FTPF,FTP,FTP1

      OPEN    (UNIT=1,NAME='INGTEMP.DAT',TYPE='OLD',
     *        CARRIAGECONTROL='LIST',RECL=132)

      OPEN    (UNIT=2,NAME='INGMAPTOPS.VAR',TYPE='OLD',
     *        CARRIAGECONTROL='LIST')


      READ(2,15,END=20)FMA,FMAZ,FMA1,FMB,FMBZ,FMB1,FMC,FMCZ,FMD,
     *FMDZ,FME,FMEZ,FMF,FMFZ,OUTFILE,ELEVGR,ELEVDF,ELEVRB,ELEVRT
 15   FORMAT(A4/A1/A4/A4/A1/A4/A4/A1/A4/A1/A4/A1/A4/A1/A32/4(I2/))


 20   READ(1,30,END=200)API,LONG,LAT,ELEV,
     * ELEVR,FTP,FMAGE,FORM,FMZ,TRS,SPOT,WELLN,LNAME,OPER
 30   FORMAT(A14,2(F9.5),I5,A2,A5,A3,A4,A1,A10,A8,A10,2(A15))

      OPEN    (UNIT=3,NAME= OUTFILE ,TYPE='NEW',
     *        CARRIAGECONTROL='LIST',RECL=400)

         FTPA = '     '
       FMAGEA = '   '
        FORMA = '    '
        FMAZ = ' '
         FTPB = '     '
       FMAGEB = '   '
        FORMB = '    '
        FMBZ = ' '
         FTPC = '     '
       FMAGEC = '   '
        FORMC = '    '
        FMCZ = ' '
         FTPD = '     '
       FMAGED = '   ' 
        FORMD = '    '
        FMDZ = ' '
         FTPE = '     '
       FMAGEE = '   '
        FORME = '    '
        FMEZ = ' '
         FTPF = '     '
       FMAGEF = '   '
        FORMF = '    '
        FMFZ = ' '

*********************************************************************
*      The following IF THEN statement adds user supplied footages  *
*      to various datums to normalize them to kelly bushing.        *
*********************************************************************

 40    IF (ELEVR .EQ. 'GR')THEN
           ELEV = ELEV + ELEVGR
          ELEVR = 'EK'
        ELSE IF (ELEVR .EQ. 'TS')THEN
           ELEV = ELEV + ELEVGR
          ELEVR = 'EK'
        ELSE IF (ELEVR .EQ. 'ES')THEN
           ELEV = ELEV
          ELEVR = 'ES'
        ELSE IF (ELEVR .EQ. 'DF')THEN
           ELEV = ELEV + ELEVDF
          ELEVR = 'EK'
        ELSE IF (ELEVR .EQ. 'RB')THEN
           ELEV = ELEV + ELEVRB
          ELEVR = 'EK'
        ELSE IF (ELEVR .EQ. 'RT')THEN
           ELEV = ELEV + ELEVRT
          ELEVR = 'EK'
       END IF
***********************************************************************
*      This IF ELSE statement assigns user supplied formations and    *
*      associated tops to new variable names to facilitate later      *
*      assignment to specific column locations in the output file.    *
***********************************************************************

      IF (FORM .EQ. FMA .OR. FORM .EQ. FMA1)THEN
            FTPA = FTP
          FMAGEA = FMAGE
           FORMA = FORM
            FMAZ = FMZ
       ELSE IF (FORM .EQ. FMB .OR. FORM .EQ. FMB1)THEN
            FTPB = FTP
          FMAGEB = FMAGE
           FORMB = FORM
            FMBZ = FMZ
       ELSE IF (FORM .EQ. FMC)THEN
           FTPC  = FTP
          FMAGEC = FMAGE
           FORMC = FORM
            FMCZ = FMZ
       ELSE IF (FORM .EQ. FMD)THEN
           FTPD  = FTP
          FMAGED = FMAGE
           FORMD = FORM
            FMDZ = FMZ
       ELSE IF (FORM .EQ. FME)THEN
           FTPE  = FTP
          FMAGEE = FMAGE
           FORME = FORM
            FMEZ = FMZ
       ELSE IF (FORM .EQ. FMF)THEN
           FTPF  = FTP
          FMAGEF = FMAGE
           FORMF = FORM
            FMFZ = FMZ
      END IF

      READ(1,30,END=200)API1,LONG1,LAT1,ELEV1,ELEVR1,
     *      FTP1,FMAGE1,FORM1,FMZ1,TRS1,SPOT1,WELLN1,LNAME1,OPER1

********************************************************************
*     This IF THEN statement ensures that the formation tops are   *
*     written to the same line as the correct well record.         *
********************************************************************     

       IF  ((API1 .NE. API) .AND. (FMC .EQ. '    '))THEN
            WRITE(3,55)API,LONG,LAT,ELEV,ELEVR,
     *      FTPA,FMAGEA,FORMA,FMAZ,FTPB,FMAGEB,FORMB,
     *      FMBZ,TRS,SPOT,WELLN,LNAME,OPER
 55         FORMAT(A14,'-',2(F9.5,3X),I5,A2,2(A5,A3,A4,A1),
     *      1X,A10,1X,A8,A10,1X,2(A15,1X))
         GOTO 110
       ELSE IF  ((API1 .NE. API) .AND. (FMD .EQ. '    '))THEN
            WRITE(3,65)API,LONG,LAT,ELEV,ELEVR,
     *      FTPA,FMAGEA,FORMA,FMAZ,FTPB,FMAGEB,FORMB,FMBZ,
     *      FTPC,FMAGEC,FORMC,FMCZ,TRS,SPOT,WELLN,
     *      LNAME,OPER
 65         FORMAT(A14,'-',2(F9.5,3X),I5,A2,
     *      3(A5,A3,A4,A1),1X,A10,1X,A8,A10,1X,2(A15,1X))
         GOTO 110
      ELSE IF ((API1 .NE. API) .AND. (FME .EQ. '    '))THEN
            WRITE(3,75)API,LONG,LAT,ELEV,ELEVR,
     *      FTPA,FMAGEA,FORMA,FMAZ,FTPB,FMAGEB,FORMB,FMBZ,
     *      FTPC,FMAGEC,FORMC,FMCZ,FTPD,FMAGED,FORMD,FMDZ,
     *      TRS,SPOT,WELLN,LNAME,OPER
 75         FORMAT(A14,'-',2(F9.5,3X),I5,A2,
     *      4(A5,A3,A4,A1),1X,A10,1X,A8,A10,1X,2(A15,1X))
         GOTO 110 
      ELSE IF ((API1 .NE. API) .AND. (FMF .EQ. '    '))THEN
            WRITE(3,85)API,LONG,LAT,ELEV,ELEVR,FTPA,FMAGEA,
     *      FORMA,FMAZ,FTPB,FMAGEB,FORMB,FMBZ,FTPC,FMAGEC,
     *      FORMC,FMCZ,FTPD,FMAGED,FORMD,FMDZ,FTPE,FMAGEE,
     *      FORME,FMEZ,TRS,SPOT,WELLN,LNAME,OPER
 85         FORMAT(A14,'-',2(F9.5,3X),I5,A2,5(A5,A3,A4,A1),
     *      1X,A10,1X,A8,A10,1X,2(A15,1X))
         GOTO 110 
      ELSE IF  (API1 .NE. API)THEN
            WRITE(3,95)API,LONG,LAT,ELEV,ELEVR,
     *      FTPA,FMAGEA,FORMA,FMAZ,FTPB,FMAGEB,FORMB,FMBZ,
     *      FTPC,FMAGEC,FORMC,FMCZ,FTPD,FMAGED,FORMD,FMDZ,FTPE,
     *      FMAGEE,FORME,FMEZ,FTPF,FMAGEF,FORMF,FMFZ,
     *      TRS,SPOT,WELLN,LNAME,OPER
 95         FORMAT(A14,'-',2(F9.5,3X),I5,A2,
     *      6(A5,A3,A4,A1),1X,A10,1X,A8,A10,1X,2(A15,1X)) 

 110            API = API1
               FTP  = FTP1
              FMAGE = FMAGE1
               FORM = FORM1
                FMZ = FMZ1
               LONG = LONG1
                LAT = LAT1
               ELEV = ELEV1
              ELEVR = ELEVR1
                TRS = TRS1
               SPOT = SPOT1
              WELLN = WELLN1
              LNAME = LNAME1
               OPER = OPER1


         FTPA = '     '
       FMAGEA = '   '
        FORMA = '    '
        FMAZ = ' '
         FTPB = '     '
       FMAGEB = '   '
        FORMB = '    '
        FMBZ = ' '
         FTPC = '     '
       FMAGEC = '   '
        FORMC = '    '
        FMCZ = ' '
         FTPD = '     '
       FMAGED = '   ' 
        FORMD = '    '
        FMDZ = ' '
         FTPE = '     '
       FMAGEE = '   '
        FORME = '    '
        FMEZ = ' '
         FTPF = '     '
       FMAGEF = '   '
        FORMF = '    '
        FMFZ = ' '

       ELSE
            FTP  = FTP1
           FMAGE = FMAGE1
            FORM = FORM1
             FMZ = FMZ1
      END IF 
       GOTO 40

 200   CLOSE (UNIT=1)
       CLOSE (UNIT=2)
       CLOSE (UNIT=3)    
       STOP 
       END        
